"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var defaultYup = require("yup");
// const yup = require("yup");
var GenerateSchema = function (schema, config, customYup) {
    var yup = customYup || defaultYup;
    var name = config.name, validationType = config.validationType, _a = config.validations, validations = _a === void 0 ? [] : _a;
    // check if the validationType (string,number..) is valid yup validator if it's not return the schema without this field validation.
    if (!yup[validationType]) {
        return schema;
    }
    var validator;
    validator = yup[validationType]();
    // for each validation on validations
    validations.forEach(function (validation) {
        // destructuring the "params" and "type" from  "validation"
        var params = validation.params, type = validation.type;
        // if no params key assign params to empty array.
        params = params || [];
        if (type === 'requiredIf') {
            // get the "fields" and "hasValues" from the "params" as separated arrays.
            var _a = params.reduce(function (acc, param) {
                acc.fields.push(param.field);
                acc.hasValues.push(param.hasValue);
                return acc;
            }, { fields: [], hasValues: [] }), fields = _a.fields, hasValues_1 = _a.hasValues;
            validator = yup[validationType]().when(fields, {
                is: function () {
                    var values = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        values[_i] = arguments[_i];
                    }
                    return values.every(function (value, index) {
                        // if the field require on multiple values
                        if (Array.isArray(hasValues_1[index])) {
                            return hasValues_1[index].includes(value);
                        }
                        return value === hasValues_1[index];
                    });
                },
                // if the (is:) return a true the field will be required
                then: yup[validationType]().required(),
                // else not required
                otherwise: yup[validationType](),
            });
        }
        else if (type === 'matches') {
            // convert string to regex
            var reg = new RegExp(params[0]);
            // to remove the regex from the params
            params.shift();
            validator = validator.matches.apply(validator, __spreadArrays([reg], params));
        }
        else {
            validator = validator[type].apply(validator, params);
        }
    });
    // add the new validator to the schema and return the schema.
    schema[name] = validator;
    return schema;
};
exports.default = GenerateSchema;
